/*
	Töötab all good.
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

typedef struct {
	double kestvus;
	char nimi[15];
} sort;
typedef struct {
	char riik[15];
	char nimi[15];
	double algus;
	double lopp;
	int doping;
} sportlane;

typedef struct {
	double tulemus_aeg; 
	sportlane s;
} aeg;

typedef struct {
	int koht;
	aeg sportlase_aeg;
} tulemus;

// funktsioon tagastab faili andmete rea arvu
int count_file_rows(FILE *);
// leitakse sportlase rajal olemise kestvus ja funktsioon tagastab aeg kirjena andmed
aeg* duration_on_track(FILE *, aeg *, int);
// sportlased sorditakse rajal olemise aja põhjal ning lisatakse tulemus kirjesse
tulemus* sort_tulemused(aeg *, tulemus *, int);
// andmed prinditakse tulemus kirjest uute faili finishi protokollina
void finishi_protokol(FILE *, int, tulemus*);


int main() {

	int num;
	FILE *a, *t;
	
	// failis ridade arv
	num = count_file_rows(a);
	
	// viidad kirjetele
    sportlane *sptr;
    aeg *aegptr;
    tulemus * tulptr;

    // kirjedele dünaamiline mälu jaotus
    sptr = (sportlane*) malloc(num *sizeof(sportlane));
	aegptr = (aeg*) malloc(num *sizeof(aeg));
	tulptr = (tulemus*) malloc(num *sizeof(tulemus));

	
	// Arvutab rajal oldud aja
	aegptr = duration_on_track(a, aegptr, num);
	
	// Arvutab sportlase koha finishi protocolis
	tulptr = sort_tulemused(aegptr, tulptr, num);

	//Kirjutab tulemus.txt faili andmed
	finishi_protokol(t, num, tulptr);
	
}

int count_file_rows(FILE *a) {
	char ch[100];
	int i, j;

	a = fopen("andmed.txt", "r");
	i = 0;

	while(fgets(ch, 100, a) != NULL)  {
		for (j = 0;j< (int) strlen(ch);j++) {
			if (ch[j] == 10) {
			i++;
			}	
		}
	}
	
	fclose(a);
	return i -1;


}

tulemus* sort_tulemused(aeg *aegptr, tulemus *tulptr, int num){
	int i, j, k, g;
	double temp[num], value;

	// kirjed viitadele
	sort *sortptr;
	sportlane svalue;
	
	// andmete sorteerimine
	for(i = 0;i<num;i++) {
		for(j=0;j<num;j++){
			if( (aegptr + j)->tulemus_aeg > (aegptr + i)->tulemus_aeg ) {
				value = (aegptr + j)->tulemus_aeg;
				svalue = (aegptr + j)->s;

				(aegptr + j)->tulemus_aeg = (aegptr + i)->tulemus_aeg;
				(aegptr + j)->s = (aegptr + i)->s;

				(aegptr + i)->tulemus_aeg = value;
				(aegptr + i)->s = svalue;
			}
		}
	}

	k = num-1 ;
	g = 0;
	// andmete uute kirjesse kirjutamine
	for (i = 0; i<num;i++){
			if ((aegptr + i)->s.doping == 1) {
				(tulptr + k)->koht = 0;
					(tulptr + k)->sportlase_aeg = *(aegptr + i);
					k--;
					
					
				} else {
					(tulptr + g)->sportlase_aeg = *(aegptr + i);
					(tulptr + g)->koht = g + 1;
					g++;
				}
	}
	
	return tulptr;

}

aeg* duration_on_track(FILE *a, aeg *aegptr, int num) {
	int i;
	sportlane *sptr;

	// fail avatakse lugemiseks
	a = fopen("andmed.txt", "r");
	// kirje sporltase viidale sptr dünaamiline mälu jaotus
	sptr = (sportlane*) malloc(num *sizeof(sportlane));

	i = 0;
	
	
	while (fscanf(a, "%s %s %lf %lf %d", (sptr + i)->riik, (sptr + i)->nimi, &(sptr + i)->algus, &(sptr + i)->lopp, &(sptr + i)->doping) != EOF) {
		if ((((sptr + i)->lopp - (sptr + i)->algus) - ((int) fabs(((sptr + i)->lopp - (sptr + i)->algus+0.005)))) > 0.59){
			// kui tulemus on alg- ja lõppaja lahutamisel üle 0.6 (minutid), siis lahutakse 0.4, mis parandab minutite õige arvestamise
			(aegptr + i)->tulemus_aeg =  ((sptr + i)->lopp - (sptr + i)->algus) - 0.4;
			(aegptr + i)->s = *(sptr + i);
		} else  {
			// muuljuhul toimub tavaline alg- ja lõppaja lahutamine, et saada teada sportlase aeg
			(aegptr + i)->tulemus_aeg =  ((sptr + i)->lopp - (sptr + i)->algus);
			(aegptr + i)->s = *(sptr + i);
		}

		i++;
	}
	// faili sulgemine
	fclose(a);

	return aegptr;
}

void finishi_protokol(FILE *t, int num, tulemus *tulptr) {
	int i, min;

	// avab faili ja lubab faili kirjutamise
	t = fopen("tulemus.txt", "w");

	// uute faili kirjutamine
	
	fprintf(t, "     %-10s|     %-10s|       %-10s| %-5s|\n","RIIK", "NIMI", "AEG", "KOHT");
	fprintf(t, "%s\n", "_________________________________________________________");

	while (i < num) {
		if ((int) (tulptr + i)->sportlase_aeg.tulemus_aeg == 0) {
			if ((tulptr + i)->sportlase_aeg.s.doping == 1) {
				min = (int) ((((tulptr + i)->sportlase_aeg.tulemus_aeg - (int) ((tulptr + i)->sportlase_aeg.tulemus_aeg + 0.005)) * 100) + 0.005);
				fprintf(t, "%-15s|   %-12s|     %-3dmin      |  %-4s|\n",(tulptr + i)->sportlase_aeg.s.riik, (tulptr + i)->sportlase_aeg.s.nimi, min, "DNF");
			} else {
				min = (int) ((((tulptr + i)->sportlase_aeg.tulemus_aeg - (int) ((tulptr + i)->sportlase_aeg.tulemus_aeg + 0.005)) * 100) + 0.005);
				fprintf(t, "%-15s|   %-12s|     %-3dmin      |  %-4d|\n",(tulptr + i)->sportlase_aeg.s.riik, (tulptr + i)->sportlase_aeg.s.nimi, min, (tulptr + i)->koht);
			}
			
		} else {
			if ((tulptr + i)->sportlase_aeg.s.doping == 1) {
				min = (int) ((((tulptr + i)->sportlase_aeg.tulemus_aeg - (int) ((tulptr + i)->sportlase_aeg.tulemus_aeg + 0.005)) *100) + 0.005);
				fprintf(t, "%-15s|   %-12s|    %dh %-3dmin    |  %-4s|\n",(tulptr + i)->sportlase_aeg.s.riik, (tulptr + i)->sportlase_aeg.s.nimi, (int) ((tulptr + i)->sportlase_aeg.tulemus_aeg+0.005), min, "DNF");
			} else {
				
				min = (int) ((((tulptr + i)->sportlase_aeg.tulemus_aeg - (int) ((tulptr + i)->sportlase_aeg.tulemus_aeg + 0.005)) * 100) + 0.005);
				fprintf(t, "%-15s|   %-12s|    %dh %-3dmin    |  %-4d|\n",(tulptr + i)->sportlase_aeg.s.riik, (tulptr + i)->sportlase_aeg.s.nimi, (int) ((tulptr + i)->sportlase_aeg.tulemus_aeg+0.005), min, (tulptr + i)->koht);
			}	
		}
		i++;
	}
	printf("Andmetöötlus edukas.\nKõikide riikide ühine protocol on failis tulemus.txt\n");
	// faili sulgemine
	fclose(t);

}




